<?php
/*
Plugin Name: GameBattles Stats
Plugin URI: http://www.armyofdrunks.com/roster/
Description: Display the statistics for your GameBattles team.
Author: Rob McGhee
Version: 2.1
Author URI: http://www.llygoden.com/
*/
include_once('simple_html_dom.php');

function gamebattles($content) {
	$opentag = "[gamebattles:"; // open gamebattles plugin
	$closetag = "]"; // close gamebattles plugin
	$onlineurl = "http://live.xbox.com/en-US/MyXbox/Profile?GamerTag="; // website to check online
	$stat = "";
	$plugindir = WP_PLUGIN_DIR . '/' . str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$gbfile = "gb";
	$gbtemp = "gbtemp";
	$gberror = "gberror";

	$gb = explode($opentag, $content); // find the open tag in the content
	$gb = explode($closetag, $gb[1]); // find the close tag in the content
	$gb = $gb[0];
	
	$replaced = $opentag . $gb . $closetag; // the string that will be replaced
	
	if ($gb == "" ){ // check that info was added
		$stat = "You must enter a valid GameBattles URL"; // error message for not having details
	}else{
		if (@file_exists($plugindir . $gbfile)) { // does a cache file exist?
			if (time() - 86400 > @filemtime($plugindir . $gbfile)){ // if the file is older than 24hrs
				if (@file_exists($plugindir . $gberror)) { // does an error file exist?
					if (time() - 21600 > @filemtime($plugindir . $gberror)){			
						@file_put_contents($plugindir . $gbtemp,@file_get_contents($gb)); // get new data from GB into temp file
						if (!strpos($plugindir . $gbtemp, "<html>")) {
							rename($plugindir . $gbtemp, $plugindir . $gbfile); // put it into GB file
							unlink($plugindir . $gberror); // remove the error file
						}else{
							rename($plugindir . $gbtemp, $plugindir . $gberror); // put it into error file
							$stat = "GameBattles is down so using data " . String((@filemtime($plugindir . $gbfile)/60)/60) . " hours old<br />";
						}
					}else{
						$stat = "GameBattles is down so using data " . String((@filemtime($plugindir . $gbfile)/60)/60) . " hours old";
					}
				}else{
					@file_put_contents($plugindir . $gbtemp,@file_get_contents($gb)); // get new data from GB into temp file
					if (!strpos($plugindir . $gbtemp, "<html>")) {
						rename($plugindir . $gbtemp, $plugindir . $gbfile); // put it into GB file
					}else{
						rename($plugindir . $gbtemp, $plugindir . $gberror); // put it into error file
						$stat = "GameBattles is down so using data " . String((@filemtime($plugindir . $gbfile)/60)/60) . " hours old<br />";
					}
				}
			}
		}else{
			@file_put_contents($plugindir . $gbfile,@file_get_contents($gb)); // create the file for the first time
		}
		
		if(!$feed = file_get_contents($plugindir . $gbfile)){ // get gamebattles XML
			$stat = "Unable to open the GameBattles team list at the moment"; // if we can't get the file display an error message
		}else{	
			$feed = uncdata($feed);
			$feed = iconv("UTF-8","UTF-8//IGNORE",$feed);

			$gbxml = @simplexml_load_string($feed); // load into simplexml
			
			$stat .= "<table width='100%' id='roster'><thead><tr><th align='left'>Member</th><th align='left'>Role</th><th>GB Rank&trade;</th><th>XBox Live</th></tr></thead><tbody>"; // table header
			
			foreach ($gbxml->roster->player as $player){ //loop through each player
				$name = $player->name;
				$url = $player->url;
				$role = $player->role;
				$rank = number_format($player->gbRank);
				
				if (@file_exists($plugindir . trim($name))) { // does a cache file exist?
					if (time() - 900 > @filemtime($plugindir . trim($name))){ // if the file is older than 15 minutes
						@file_put_contents($plugindir . trim($name),@file_get_contents($onlineurl . str_replace(" ","+",trim($name))));
					}
				}else{
					@file_put_contents($plugindir . trim($name),@file_get_contents($onlineurl . str_replace(" ","+",trim($name))));
				}
				
				$onlinefeed = file_get_html($plugindir . trim($name)); // get file
				foreach($onlinefeed->find('div[id=CurrentActivity]') as $result){ // retrieve online status
					$online = $result->innertext;
				}
				
				$stat .= "<tr><td><a href=" . $url . " >". $name . "</td>"; // create table rows
				$stat .= "<td>" . $role . "</td>";
				$stat .= "<td align='center'>" . $rank . "</td>";
				$stat .= "<td align='center'>" . $online . "</td>";
				
				
			}
			
			$stat .= "</tbody></table><br />";
			
		}
	}
	
	$content = str_replace($replaced, $stat,$content); // replace the string in the original text
	
	return $content; // return the text 

}

function uncdata($xml) // format UNCDATA
    {
        $state = 'out';
        $a = str_split($xml);
        $new_xml = '';

        foreach ($a AS $k => $v) {
            // Deal with "state".
            switch ( $state ) {
                case 'out':
                    if ( '<' == $v ) {
                        $state = $v;
                    } else {
                        $new_xml .= $v;
                    }
                break;

                case '<':
                    if ( '!' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                 case '<!':
                    if ( '[' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![':
                    if ( 'C' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![C':
                    if ( 'D' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CD':
                    if ( 'A' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDA':
                    if ( 'T' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDAT':
                    if ( 'A' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case '<![CDATA':
                    if ( '[' == $v  ) {


                        $cdata = '';
                        $state = 'in';
                    } else {
                        $new_xml .= $state . $v;
                        $state = 'out';
                    }
                break;

                case 'in':
                    if ( ']' == $v ) {
                        $state = $v;
                    } else {
                        $cdata .= $v;
                    }
                break;

                case ']':
                    if (  ']' == $v  ) {
                        $state = $state . $v;
                    } else {
                        $cdata .= $state . $v;
                        $state = 'in';
                    }
                break;

                case ']]':
                    if (  '>' == $v  ) {
                        $new_xml .= str_replace('>','&gt;',
                                    str_replace('>','&lt;',
                                    str_replace('"','&quot;',
                                    str_replace('&','&amp;',
                                    $cdata))));
                        $state = 'out';
                    } else {
                        $cdata .= $state . $v;
                        $state = 'in';
                    }
                break;
            } // switch
        }
        return $new_xml;
    }

add_filter('the_content','gamebattles');

?>